----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 12/03/2020 10:33:51 AM
-- Design Name: 
-- Module Name: pps_gen - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity pps_gen is
  Generic(
    freq_hz : integer := 50000000;
    pps_width : integer := 10000
  );
  Port ( 
    clk_i : in std_logic;
    rstn_i : in std_logic;
    pps_o : out std_logic
  );
end pps_gen;

architecture Behavioral of pps_gen is

    signal second_counter : integer;
    signal pps_counter : integer;
    signal pps_internal_pulse : std_logic;
    signal pps_internal : std_logic;

begin

 process(clk_i)
 begin
   if rising_edge(clk_i) then
    if(rstn_i = '0') then
      second_counter <= 0;
      pps_internal_pulse <= '0';
    else
      if(second_counter = freq_hz - 1) then
        pps_internal_pulse <= '1';
        second_counter <= 0;
      else
        pps_internal_pulse <= '0';
        second_counter <= second_counter + 1;
      end if;
    end if;
   end if;
 end process;
 
 process(clk_i)
 begin
   if rising_edge(clk_i) then
    if(rstn_i = '0') then
      pps_counter <= 0;
      pps_internal <= '0';    
    else
      if(pps_internal_pulse = '1') then
        pps_counter <= pps_width + 1;
        pps_internal <= '1'; 
      elsif(pps_counter > 0) then
        pps_counter <= pps_counter - 1;   
        pps_internal <= '1';
      else
        pps_internal <= '0';
      end if;
    end if;
   end if;
 end process;

pps_o <= pps_internal;

end Behavioral;
